--- /dev/null
+++ b/zipl/boot/cio.c
@@ -0,0 +1,273 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common IO functions for channel based devices.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "cio.h"
+#include "error.h"
+#include "s390.h"
+#include "libc.h"
+
+static unsigned long initial_lpm = 0x00;
+static const char *msg_essch = "Start subchannel failed";
+static const char *msg_eenable_dev = "Enable device failed";
+
+static int clear_subchannel(struct subchannel_id subchannel_id)
+{
+	register struct subchannel_id reg1 asm ("1") = subchannel_id;
+	int rc;
+
+	asm volatile(
+		"     csch\n"
+		"     ipm    %0\n"
+		"     srl    %0,28\n"
+		: "=d" (rc)
+		: "d" (reg1)
+		: "cc");
+	return rc;
+}
+
+static int test_subchannel(struct subchannel_id subchannel_id, struct irb *irb)
+{
+	register struct subchannel_id reg1 asm ("1") = subchannel_id;
+	int rc;
+
+	asm volatile(
+		"       tsch    0(%3)\n"
+		"       ipm     %0\n"
+		"       srl     %0,28\n"
+		: "=d" (rc), "=m" (*irb)
+		: "d" (reg1), "a" (irb)
+		: "cc");
+	return rc;
+}
+
+static int start_subchannel(struct subchannel_id subchannel_id, struct orb *orb)
+{
+	register struct subchannel_id reg1 asm ("1") = subchannel_id;
+	int rc;
+
+	asm volatile(
+		"      ssch    0(%2)\n"
+		"      ipm     %0\n"
+		"      srl     %0,28\n"
+		: "=d" (rc)
+		: "d" (reg1), "a" (orb), "m" (*orb)
+		: "cc", "memory");
+	return rc;
+}
+
+int store_subchannel(struct subchannel_id subchannel_id, struct schib *schib)
+{
+	register struct subchannel_id reg1 asm ("1") = subchannel_id;
+	int ccode;
+
+	asm volatile(
+		"      stsch    0(%3)\n"
+		"      ipm      %0\n"
+		"      srl      %0,28\n"
+		: "=d" (ccode), "=m" (*schib)
+		: "d" (reg1), "a" (schib)
+		: "cc");
+	return ccode;
+}
+
+static int modify_subchannel(struct subchannel_id subchannel_id,
+			     struct schib *schib)
+{
+	register struct subchannel_id reg1 asm ("1") = subchannel_id;
+	int rc;
+
+	asm volatile(
+		"      msch    0(%2)\n"
+		"      ipm     %0\n"
+		"      srl     %0,28\n"
+		: "=d" (rc)
+		: "d" (reg1), "a" (schib), "m" (*schib)
+		: "cc");
+	return rc;
+}
+
+void io_irq_enable(void)
+{
+	unsigned long ctl = 0xff000000;
+
+	__ctl_load(ctl, 6, 6);
+}
+
+
+void io_irq_disable(void)
+{
+	unsigned long ctl = 0x00000000;
+
+	__ctl_load(ctl, 6, 6);
+}
+
+/*
+ * load wait psw and test subchannel after interrupt was received
+ * return condition code
+ */
+static int wait_for_int(struct subchannel_id subchannel_id, struct irb *irb)
+{
+	int rc;
+
+	do {
+		load_wait_psw(0x0202000180000000ULL, &S390_lowcore.io_new_psw);
+		rc = test_subchannel(subchannel_id, irb);
+	} while (rc == 1);
+
+	return rc;
+}
+
+/*
+ * get next path for IO
+ * call panic if no path is left
+ */
+static uint32_t next_path(uint32_t mask, struct subchannel_id subchannel_id,
+			  struct irb *irb)
+{
+	if (!initial_lpm) {
+		mask >>= 1;
+		if (mask == 0)
+			panic(ESSCH, "%s", msg_essch);
+	}
+
+	/* clear initial path mask to iterate throu other paths, too */
+	initial_lpm = 0;
+
+	if (clear_subchannel(subchannel_id))
+		panic(ESSCH, "%s", msg_essch);
+
+	wait_for_int(subchannel_id, irb);
+
+	return mask;
+}
+
+void start_io(struct subchannel_id subchannel_id, struct irb *irb,
+	      struct orb *orb)
+{
+	uint32_t mask = FIRST_PATH_MASK;
+	struct scsw *scsw;
+	int rc, retry = MAX_RETRIES;
+
+	while (1) {
+		/*
+		 * set path mask in orb to initial path mask or to current mask
+		 * initial_lpm gets cleared in next_path()
+		 */
+		if (!initial_lpm)
+			orb->lpm = mask;
+		else
+			orb->lpm = initial_lpm;
+
+		rc = start_subchannel(subchannel_id, orb);
+		if (rc == CC_NOT_OPER) {
+			mask = next_path(mask, subchannel_id, irb);
+			retry = MAX_RETRIES;
+			continue;
+		} else if (rc != CC_INITIATED) {
+			/*
+			 * possible status pending
+			 * call test_subchannel to clear and retry
+			 */
+			goto retry;
+		}
+
+		scsw = (struct scsw *)irb;
+		/* wait for interrupt and device is ready */
+		do {
+			rc = wait_for_int(subchannel_id, irb);
+			if (rc)
+				panic(ESSCH, "%s", msg_essch);
+
+			/* device end */
+			if (scsw->dstat & 0x04)
+				break;
+			/* deferred condition code */
+			if (scsw->cc != 0)
+				break;
+			/* status alert set */
+			if (scsw->stctl & 0x10)
+				break;
+			/* channel state */
+			if (scsw->cstat & 0xff)
+				break;
+		} while (1);
+
+		/* path not operational */
+		if (scsw->cc == 3) {
+			mask = next_path(mask, subchannel_id, irb);
+			retry = MAX_RETRIES;
+			continue;
+		}
+
+		/*
+		 * If no deferred condition code is set as well as
+		 * no channel status, no alert status control and no device
+		 * status except channel_end and device_end, we are done.
+		 */
+		if (scsw->cc == 0 &&
+		    scsw->cstat == 0 &&
+		    scsw->dstat & 0x04 &&
+		    !(scsw->stctl & 0x10) &&
+		    !(scsw->dstat & 0xf3))
+			return;
+
+retry:
+		/* else we clear the subchannel and do a retry */
+		test_subchannel(subchannel_id, irb);
+		retry--;
+
+		/*
+		 * if no retry is left we try another path;
+		 * if no path is left it will panic
+		 */
+		if (retry <= 0) {
+			mask = next_path(mask, subchannel_id, irb);
+			retry = MAX_RETRIES;
+		}
+	}
+}
+
+void set_device(struct subchannel_id subchannel_id, int enabled)
+{
+	struct schib schib;
+	struct irb *irb;
+	int i, rc;
+
+	irb = (struct irb *)&S390_lowcore.irb;
+	rc = store_subchannel(subchannel_id, &schib);
+
+	if (rc == CC_NOT_OPER)
+		/* Panic if path not operational */
+		panic(EENABLE_DEV, "%s", msg_eenable_dev);
+
+	/* enable/disable subchannel */
+	schib.pmcw.ena = enabled ? ENABLED : DISABLED;
+
+	for (i = 0; i < 256; i++) {
+		rc = modify_subchannel(subchannel_id, &schib);
+		if (!rc) {
+			/* successful */
+			break;
+		} else if (rc == CC_STATUS_PENDING || rc == CC_BUSY) {
+			/* call test_subchannel to clear pending status */
+			rc = test_subchannel(subchannel_id, irb);
+			if (rc == CC_NOT_OPER)
+				panic(EENABLE_DEV, "%s", msg_eenable_dev);
+		} else if (rc == CC_NOT_OPER) {
+			/* Panic if path not operational */
+			panic(EENABLE_DEV, "%s", msg_eenable_dev);
+		}
+	}
+
+	if (!enabled)
+		return;
+
+	/* set initial lpm to lpum if path is enabled and 0 if not */
+	initial_lpm = rc ? 0 : schib.pmcw.lpum;
+}
--- /dev/null
+++ b/zipl/boot/cio.h
@@ -0,0 +1,145 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common I/O functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ *            Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+#ifndef CIO_H
+#define CIO_H
+
+#include "libc.h"
+#include "s390.h"
+
+/* Condition codes */
+#define CC_INITIATED		0
+#define CC_STATUS_PENDING	1
+#define CC_BUSY			2
+#define CC_NOT_OPER		3
+
+/* CCW FLAGS */
+#define CCW_FLAG_IDA		0x04
+#define CCW_FLAG_CC		0x40
+#define CCW_FLAG_SLI		0x20
+
+#define FIRST_PATH_MASK		0x80
+
+#define DISABLED		0
+#define ENABLED			1
+
+#define MAX_RETRIES		255
+
+struct subchannel_id {
+	uint32_t cssid:8;
+	uint32_t:4;
+	uint32_t m:1;
+	uint32_t ssid:2;
+	uint32_t one:1;
+	uint32_t sch_no:16;
+} __packed __aligned(4);
+
+struct ccw1 {
+	uint8_t cmd_code;
+	uint8_t flags;
+	uint16_t count;
+	uint32_t cda;
+}  __packed __aligned(8);
+
+struct irb {
+	uint8_t data[64];
+} __packed __aligned(4);
+
+struct orb {
+	uint32_t intparm;	/* interruption parameter */
+	uint32_t key:4;		/* flags, like key, suspend control, etc. */
+	uint32_t spnd:1;	/* suspend control */
+	uint32_t res1:1;	/* reserved */
+	uint32_t mod:1;		/* modification control */
+	uint32_t sync:1;	/* synchronize control */
+	uint32_t fmt:1;		/* format control */
+	uint32_t pfch:1;	/* prefetch control */
+	uint32_t isic:1;	/* initial-status-interruption control */
+	uint32_t alcc:1;	/* address-limit-checking control */
+	uint32_t ssic:1;	/* suppress-suspended-interr. control */
+	uint32_t res2:1;	/* reserved */
+	uint32_t c64:1;		/* IDAW/QDIO 64 bit control  */
+	uint32_t i2k:1;		/* IDAW 2/4kB block size control */
+	uint32_t lpm:8;		/* logical path mask */
+	uint32_t ils:1;		/* incorrect length */
+	uint32_t zero:6;	/* reserved zeros */
+	uint32_t orbx:1;	/* ORB extension control */
+	uint32_t cpa;		/* channel program address */
+	uint8_t reserved[20];
+} __packed __aligned(4);
+
+struct scsw {
+	uint32_t key:4;
+	uint32_t sctl:1;
+	uint32_t eswf:1;
+	uint32_t cc:2;
+	uint32_t fmt:1;
+	uint32_t pfch:1;
+	uint32_t isic:1;
+	uint32_t alcc:1;
+	uint32_t ssi:1;
+	uint32_t zcc:1;
+	uint32_t ectl:1;
+	uint32_t pno:1;
+	uint32_t res:1;
+	uint32_t fctl:3;
+	uint32_t actl:7;
+	uint32_t stctl:5;
+	uint32_t cpa;
+	uint32_t dstat:8;
+	uint32_t cstat:8;
+	uint32_t count:16;
+} __packed;
+
+struct pmcw {
+	uint32_t intparm;	/* interruption parameter */
+	uint32_t qf:1;
+	uint32_t w:1;
+	uint32_t isc:3;		/* interruption sublass */
+	uint32_t res5:3;	/* reserved zeros */
+	uint32_t ena:1;		/* enabled */
+	uint32_t lm:2;		/* limit mode */
+	uint32_t mme:2;		/* measurement-mode enable */
+	uint32_t mp:1;		/* multipath mode */
+	uint32_t tf:1;		/* timing facility */
+	uint32_t dnv:1;		/* device number valid */
+	uint32_t dev:16;	/* device number */
+	uint8_t  lpm;		/* logical path mask */
+	uint8_t  pnom;		/* path not operational mask */
+	uint8_t  lpum;		/* last path used mask */
+	uint8_t  pim;		/* path installed mask */
+	uint16_t mbi;		/* measurement-block index */
+	uint8_t  pom;		/* path operational mask */
+	uint8_t  pam;		/* path available mask */
+	uint8_t  chpid[8];	/* CHPID 0-7 (if available) */
+	uint32_t unused1:8;	/* reserved zeros */
+	uint32_t st:3;
+	uint32_t unused2:18;	/* reserved zeros */
+	uint32_t mbfc:1;	/* measurement block format control */
+	uint32_t xmwme:1;	/* extended measurement word mode enable */
+	uint32_t csense:1;	/* concurrent sense; can be enabled ...*/
+				/*  ... per MSCH, however, if facility */
+				/*  ... is not installed, this results */
+				/*  ... in an operand exception.       */
+} __packed;
+
+struct schib {
+	struct pmcw pmcw;	/* path management control word */
+	struct scsw scsw;	/* subchannel status word */
+	uint64_t mba;		/* measurement block address */
+	uint8_t mda[4];		/* model dependent area */
+} __packed __aligned(4);
+
+void start_io(struct subchannel_id , struct irb *, struct orb *);
+int store_subchannel(struct subchannel_id, struct schib *);
+void io_irq_enable(void);
+void io_irq_disable(void);
+void set_device(struct subchannel_id, int);
+
+#endif /* CIO_H */
--- /dev/null
+++ b/zipl/boot/eckd.h
@@ -0,0 +1,42 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * DASD ECKD specific functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ *
+ */
+
+#ifndef ECKD_H
+#define ECKD_H
+
+#include "stage2.h"
+
+/* CCW COMMANDS */
+#define DASD_ECKD_CCW_SEEK		0x07
+#define DASD_ECKD_CCW_TIC		0x08
+#define DASD_ECKD_CCW_SEARCH		0x31
+#define DASD_ECKD_CCW_READ_MT		0x86
+
+struct ch_t {
+	uint16_t cyl;
+	uint16_t head;
+} __packed;
+
+struct chr_t {
+	uint16_t cyl;
+	uint16_t head;
+	uint8_t record;
+} __packed __aligned(8);
+
+struct seek_arg {
+	uint16_t zeroes;
+	struct ch_t ch;
+} __packed __aligned(8);
+
+struct indirect_block {
+	uint64_t *block;
+} __packed;
+
+#endif /* ECKD_H */
--- /dev/null
+++ b/zipl/boot/eckd0_cdl.S
@@ -0,0 +1,20 @@
+#
+# IPL stage 0 loader for ECKD Compatible Disk Layout (CDL)
+#
+# Copyright IBM Corp. 2001, 2012
+# Author(s): Antoinette Kaschner (anto@de.ibm.com)
+#            Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Startup for IPL at address 0
+# Second stage boot loader is loaded to 0x2000 and starts at 0x2018
+#
+# The first 24 bytes are loaded by IPL to addresses 0-23 (PSW and two CCWs).
+# The 1st CCW reads stage 1 IPL record.
+# The 2nd CCW tics to the loaded stage 1 IPL record.
+#
+	.org   0x0
+	.globl _start
+_start:
+	.long  0x00080000,0x80002018 # PSW :the first 24 byte are loaded by IPL
+	.long  0x06000018,0x60000068 # read IPL record 2
+	.long  0x08000018,0x00000000 # TIC to stage 1
--- /dev/null
+++ b/zipl/boot/eckd0_ldl.S
@@ -0,0 +1,21 @@
+#
+# IPL stage 0 loader for ECKD Linux Disk Layout (LDL)
+#
+# Copyright IBM Corp. 2001, 2012
+# Author(s): Antoinette Kaschner (anto@de.ibm.com)
+#            Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Startup for IPL at address 0
+# Second stage boot loader is loaded to 0x2000 and starts at 0x2018
+#
+# The first 24 bytes are loaded by IPL to addresses 0-23 (PSW and two CCWs).
+# The 1st CCW rewinds to record zero (read record zero)
+# The 2nd CCW reads stage 1 IPL record (re-read record 1) and continues with
+# command chaining at address 0x18
+#
+	.org   0x0
+	.globl _start
+_start:
+	.long  0x00080000,0x80002018 # PSW :the first 24 byte are loaded by IPL
+	.long  0x16002000,0x60000016 # Read record zero
+	.long  0x06000000,0x60000080 # Read IPL record 1 again
--- a/zipl/boot/eckd1.S
+++ b/zipl/boot/eckd1.S
@@ -1,35 +1,36 @@
 #
-#  Ipl stage 1 loader
-#    Copyright IBM Corp. 2001, 2006.
-#    Author(s): Antoinette Kaschner (anto@de.ibm.com),
+# IPL stage 1 loader for ECKD
 #
-#  startup for ipl at address 0
-#  second stage boot loader is loaded to 0x2000 and starts at 0x2008
+# Copyright IBM Corp. 2001, 2012
+# Author(s): Antoinette Kaschner (anto@de.ibm.com)
+#            Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Stage 1 is loaded to 0x18-0x80 and is used to load stage 1b (two blocks) with
+# seek/search/tic/read CCWs. After stage 1b is loaded we tic to it.
+
+	.globl _start
+_start:
+	.long  0x07000000+.Lseek1,0x60000006    # seek 1
+.Lsearch1:
+	.long  0x31000000+.Lseek1+2,0x60000005  # search
+	.long  0x08000000+.Lsearch1,0x00000000  # tic back to search until found
+	.long  0x06000000,0x40000000            # read
+
+	.long  0x07000000+.Lseek2,0x60000006    # seek 2
+.Lsearch2:
+	.long  0x31000000+.Lseek2+2,0x60000005  # search
+	.long  0x08000000+.Lsearch2,0x00000000  # tic back to search until found
+	.long  0x06000000,0x40000000            # read
+.Ltick:
+	.long  0x08000000,0x00000000            # tic to stage 1b
+.Lseek1:
+	.long  0x00000000,0x00000000            # seekarg 1
+.Lseek2:
+	.long  0x00000000,0x00000000            # seekarg 2
 
-# The first 24 bytes are loaded by ipl to addresses 0-23 (a PSW and two CCWs).
-# IPL1 record TICs to IPL2 record at offset X'68' .Byte 0 to 68 of IPL2 contains boot load data.
-# The seek/search/tic/read CCWs at the end of IPL2 record reads  record 2 on disk into storage at
-# location X200.	 
-	
-	
-		.org   0x18
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x00000000,0x00000000           # contains boot load data 
-	.long  0x07600006,0x00000000+.Lseek    # seek  
-.Lsearch:	
-	.long  0x31600005,0x00000000+.Lseek+2  # search
-	.long  0x08000000,0x00000000+.Lsearch  # tic back to search until found
-	.long  0x06200090,0x00000200           # read record 2 into storage
- .Lseek:
-	.long  0x00000000,0x00000200           # seekargument for cyl 0 hd 0 rec 2   
+	.long  0x00000000,0x00000000            # bootinfo
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
+	.long  0x00000000,0x00000000
+.Lend:
--- a/zipl/boot/eckd1b.S
+++ b/zipl/boot/eckd1b.S
@@ -1,37 +1,184 @@
 #
-#  Ipl stage 1b loader new disk layout
-#    Copyright IBM Corp. 2001, 2006.
-#    Author(s): Antoinette Kaschner (anto@de.ibm.com),
+# IPL stage 1b loader for ECKD
+#
+# Copyright IBM Corp. 2012
+#
+# Author(s): Michael Holzheu (holzheu@linux.vnet.ibm.com)
+#
+# Stage 1b is loaded to 0xe000-0xe400 and is used to load stage 2 with
+# seek/search/tic/read CCWs. Currently stage 1b can load up to 16
+# blocks and therefore 8 KiB stage 2 code with 512 byte block size.
 #
-#  startup for ipl at address 0
-#  second stage boot loader is loaded to 0x2000 and starts at 0x2008
 
-# The first 24 bytes are loaded by ipl to addresses 0-23 (a PSW and two CCWs).
-# IPL1 record TICs to IPL2 record at offset X'218' .Byte 218 to 362 of IPL2 contains 
-# seek/search/tic/read CCWs .	 
-	
-	
 	.globl _start
 _start:
-	.long  0,0                             # bootlist data
+	.long  0x07000000+.Lseek1,0x60000006     # seek
+.Lsearch1:
+	.long  0x31000000+.Lseek1+2,0x60000005   # search
+	.long  0x08000000+.Lsearch1,0x00000000   # tic back until found
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek2,0x60000006     # seek
+.Lsearch2:
+	.long  0x31000000+.Lseek2+2,0x60000005   # search
+	.long  0x08000000+.Lsearch2,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek3,0x60000006     # seek
+.Lsearch3:
+	.long  0x31000000+.Lseek3+2,0x60000005   # search
+	.long  0x08000000+.Lsearch3,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek4,0x60000006     # seek
+.Lsearch4:
+	.long  0x31000000+.Lseek4+2,0x60000005   # search
+	.long  0x08000000+.Lsearch4,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek5,0x60000006     # seek
+.Lsearch5:
+	.long  0x31000000+.Lseek5+2,0x60000005   # search
+	.long  0x08000000+.Lsearch5,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek6,0x60000006     # seek
+.Lsearch6:
+	.long  0x31000000+.Lseek6+2,0x60000005   # search
+	.long  0x08000000+.Lsearch6,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek7,0x60000006     # seek
+.Lsearch7:
+	.long  0x31000000+.Lseek7+2,0x60000005   # search
+	.long  0x08000000+.Lsearch7,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek8,0x60000006     # seek
+.Lsearch8:
+	.long  0x31000000+.Lseek8+2,0x60000005   # search
+	.long  0x08000000+.Lsearch8,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek9,0x60000006     # seek
+.Lsearch9:
+	.long  0x31000000+.Lseek9+2,0x60000005   # search
+	.long  0x08000000+.Lsearch9,0x00000000   # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek10,0x60000006    # seek
+.Lsearch10:
+	.long  0x31000000+.Lseek10+2,0x60000005  # search
+	.long  0x08000000+.Lsearch10,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek11,0x60000006    # seek
+.Lsearch11:
+	.long  0x31000000+.Lseek11+2,0x60000005  # search
+	.long  0x08000000+.Lsearch11,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek12,0x60000006    # seek
+.Lsearch12:
+	.long  0x31000000+.Lseek12+2,0x60000005  # search
+	.long  0x08000000+.Lsearch12,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek13,0x60000006    # seek
+.Lsearch13:
+	.long  0x31000000+.Lseek13+2,0x60000005  # search
+	.long  0x08000000+.Lsearch13,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek14,0x60000006    # seek
+.Lsearch14:
+	.long  0x31000000+.Lseek14+2,0x60000005  # search
+	.long  0x08000000+.Lsearch14,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek15,0x60000006    # seek
+.Lsearch15:
+	.long  0x31000000+.Lseek15+2,0x60000005  # search
+	.long  0x08000000+.Lsearch15,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek16,0x60000006    # seek
+.Lsearch16:
+	.long  0x31000000+.Lseek16+2,0x60000005  # search
+	.long  0x08000000+.Lsearch16,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek17,0x60000006    # seek
+.Lsearch17:
+	.long  0x31000000+.Lseek17+2,0x60000005  # search
+	.long  0x08000000+.Lsearch17,0x00000000  # tic back until found
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek18,0x60000006    # seek
+.Lsearch18:
+	.long  0x31000000+.Lseek18+2,0x60000005  # search
+	.long  0x08000000+.Lsearch18,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek19,0x60000006    # seek
+.Lsearch19:
+	.long  0x31000000+.Lseek19+2,0x60000005  # search
+	.long  0x08000000+.Lsearch19,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek20,0x60000006    # seek
+.Lsearch20:
+	.long  0x31000000+.Lseek20+2,0x60000005  # search
+	.long  0x08000000+.Lsearch20,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek21,0x60000006    # seek
+.Lsearch21:
+	.long  0x31000000+.Lseek21+2,0x60000005  # search
+	.long  0x08000000+.Lsearch21,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek22,0x60000006    # seek
+.Lsearch22:
+	.long  0x31000000+.Lseek22+2,0x60000005  # search
+	.long  0x08000000+.Lsearch22,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek23,0x60000006    # seek
+.Lsearch23:
+	.long  0x31000000+.Lseek23+2,0x60000005  # search
+	.long  0x08000000+.Lsearch23,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+	.long  0x07000000+.Lseek24,0x60000006    # seek
+.Lsearch24:
+	.long  0x31000000+.Lseek24+2,0x60000005  # search
+	.long  0x08000000+.Lsearch24,0x00000000  # tic back
+	.long  0x06000000,0x40000000             # read
+.Lseek1:
+	.long  0,0
+.Lseek2:
+	.long  0,0
+.Lseek3:
+	.long  0,0
+.Lseek4:
+	.long  0,0
+.Lseek5:
+	.long  0,0
+.Lseek6:
+	.long  0,0
+.Lseek7:
+	.long  0,0
+.Lseek8:
+	.long  0,0
+.Lseek9:
+	.long  0,0
+.Lseek10:
+	.long  0,0
+.Lseek11:
+	.long  0,0
+.Lseek12:
+	.long  0,0
+.Lseek13:
+	.long  0,0
+.Lseek14:
+	.long  0,0
+.Lseek15:
+	.long  0,0
+.Lseek16:
+	.long  0,0
+.Lseek17:
+	.long  0,0
+.Lseek18:
+	.long  0,0
+.Lseek19:
+	.long  0,0
+.Lseek20:
+	.long  0,0
+.Lseek21:
+	.long  0,0
+.Lseek22:
+	.long  0,0
+.Lseek23:
+	.long  0,0
+.Lseek24:
 	.long  0,0
-	.long  0x07000000+.Lseek,0x60000006    # seek  
-.Lsearch:	
-	.long  0x31000000+.Lseek+2,0x60000005  # search
-	.long  0x08000000+.Lsearch,0x00000000  # tic back to search until found
-	.long  0x06002000,0x60000000           # read record 4 into storage
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x60000000
-	.long  0x06000000,0x20000000 
-	  
-		
- .Lseek:
-	.long  0x00000000,0x00000400           # seekargument for cyl 0 hd 0 rec 4   
+.org 1024 # Stage 1b should have 1024 byte
+.Lend:
--- /dev/null
+++ b/zipl/boot/eckd2.c
@@ -0,0 +1,97 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Subroutines for ECKD disks.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "stage2.h"
+#include "eckd.h"
+#include "s390.h"
+
+int extract_length(void *data)
+{
+	struct eckd_blockptr *blockptr = (struct eckd_blockptr *)data;
+
+	return blockptr->size * (blockptr->blockct + 1);
+}
+
+int is_zero_block(void *data)
+{
+	struct eckd_blockptr *blockptr = (struct eckd_blockptr *)data;
+
+	return blockptr->cyl  || blockptr->head || blockptr->sec;
+}
+
+void * load_direct(disk_blockptr_t *data, struct subchannel_id subchannel_id,
+	    void *load_addr)
+{
+	struct eckd_blockptr *blockptr = (struct eckd_blockptr *)data;
+	struct ccw1 *ccws;
+	unsigned long record_size;
+	struct seek_arg seek_addr;
+	struct chr_t search_arg;
+	int record_number;
+	struct irb *irb;
+	struct orb orb;
+	int i = 3;
+
+	irb = (struct irb *)&S390_lowcore.irb;
+
+	memset(irb, 0, sizeof(struct irb));
+	memset(&orb, 0, sizeof(struct orb));
+	memset(&seek_addr, 0, sizeof(struct ch_t));
+	memset(&search_arg, 0, sizeof(struct chr_t));
+
+	ccws = (struct ccw1 *)get_zeroed_page();
+
+	/* initialise SEEK, SEARCH and TIC CCW*/
+	ccws[0].cmd_code = DASD_ECKD_CCW_SEEK;
+	ccws[0].flags = CCW_FLAG_CC | CCW_FLAG_SLI;
+	ccws[0].count = 6;
+	seek_addr.ch.cyl = blockptr->cyl;
+	seek_addr.ch.head = blockptr->head;
+	ccws[0].cda = (uint32_t) (unsigned long) &seek_addr;
+
+	record_number = blockptr->blockct;
+	record_size = blockptr->size;
+
+	ccws[1].cmd_code = DASD_ECKD_CCW_SEARCH;
+	ccws[1].flags = CCW_FLAG_CC | CCW_FLAG_SLI;
+	ccws[1].count = 5;
+	search_arg.cyl = blockptr->cyl;
+	search_arg.head = blockptr->head;
+	search_arg.record = blockptr->sec;
+	ccws[1].cda = (uint32_t) (unsigned long) &search_arg;
+
+	ccws[2].cmd_code = DASD_ECKD_CCW_TIC;
+	ccws[2].flags = 0;
+	ccws[2].count = 0;
+	ccws[2].cda = (uint32_t) (unsigned long) &ccws[1];
+
+	/* initialise READ CCWs */
+	while (1) {
+		ccws[i].cmd_code = DASD_ECKD_CCW_READ_MT;
+		ccws[i].flags = CCW_FLAG_SLI;
+		ccws[i].count = record_size;
+		ccws[i].cda = (uint32_t) (unsigned long) load_addr;
+
+		record_number--;
+		load_addr += record_size;
+		i++;
+
+		if (record_number >= 0)
+			ccws[i-1].flags |= CCW_FLAG_CC;
+		else
+			break;
+	}
+	orb.fmt = 1;
+	orb.cpa = (uint32_t) (unsigned long) ccws;
+
+	start_io(subchannel_id, irb, &orb);
+
+	free_page((unsigned long)ccws);
+	return load_addr;
+}
--- /dev/null
+++ b/zipl/boot/eckd2dump.c
@@ -0,0 +1,200 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common ECKD dump I/O functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include "eckd2dump.h"
+#include "stage2dump.h"
+#include "s390.h"
+#include "cio.h"
+#include "error.h"
+
+#define CMD_LOCATE_RECORD	0x47
+#define CMD_DEFINE_EXTEND	0x63
+#define CMD_READ		0x86
+#define CMD_WRITE		0x8d
+
+struct eckd_device device;
+
+/*
+ * Data for Locate Record CCW
+ */
+struct lodata {
+	uint8_t		op;
+	uint8_t		xx;
+	uint16_t	blk_count;
+	uint32_t	cchh1;
+	uint32_t	cchh2;
+	uint8_t		bot;
+	uint8_t		res2;
+	uint16_t	blk_size;
+	uint8_t		res3[0x18-0x10];
+} __packed;
+
+static struct lodata lodata = {
+	.op		= 0x01,
+	.xx		= 0x80,
+	.blk_count	= 0x0001,
+	.bot		= 0x03,
+};
+
+/*
+ * Data for Define Extend CCW
+ */
+struct dedata {
+	uint8_t		op;
+	uint8_t		xx;
+	uint8_t		res1[0x08-0x02];
+	uint32_t	cchh1;
+	uint32_t	cchh2;
+} __packed;
+
+static struct dedata dedata = {
+	.op		= 0x80,
+	.xx		= 0xc0,
+};
+
+/*
+ * ORB /IRB
+ */
+static struct orb orb = {
+	.intparm	= 0x0049504c,	/* Interruption Parameter */
+	.fmt		= 0x1,		/* Use format 1 CCWs */
+	.c64		= 0x1,		/* Use IDAs */
+	.lpm		= 0xff,		/* Logical path mask */
+};
+
+static struct irb irb;
+
+/*
+ * CCW program and IDA list
+ */
+struct ccw_program {
+	struct ccw1 deccw;
+	struct ccw1 loccw;
+	struct ccw1 wrccw[ECKD_BPWRT_MAX];
+	unsigned long ida_list[ECKD_BPWRT_MAX];
+} __packed __aligned(8);
+
+static struct ccw_program ccw_program;
+
+/*
+ * Setup IDA list for CCW program
+ */
+static void ccw_setup(uint8_t cmd, unsigned long addr, unsigned long blk_count,
+		      unsigned long zero_page)
+{
+	unsigned long i, *ida_list = ccw_program.ida_list;
+	struct ccw1 *ccw_list = ccw_program.wrccw;
+
+	for (i = 0; i < blk_count; i++) {
+		if (zero_page)
+			ida_list[i] = page_is_valid(addr) ? addr : zero_page;
+		else
+			ida_list[i] = addr;
+		ccw_list[i].cmd_code = cmd;
+		ccw_list[i].count = device.blk_size;
+		ccw_list[i].flags = CCW_FLAG_CC | CCW_FLAG_IDA;
+		ccw_list[i].cda = __pa32(&ida_list[i]);
+		addr += device.blk_size;
+	}
+	/* No command chaining for last CCW */
+	ccw_list[i - 1].flags &= ~CCW_FLAG_CC;
+}
+
+/*
+ * Read or write ECKD blocks
+ */
+static void io_block(uint8_t cmd, unsigned long blk, unsigned long addr,
+		     unsigned long blk_count, unsigned long zero_page)
+{
+	uint32_t trk, trk_end, cyl, cyl_end, bot, hd, hd_end, c0c1c2h0, down;
+	unsigned long blk_end;
+
+	if (blk >= device.blk_end)
+		panic(EMEM, "%s", "Device too small");
+
+	ccw_setup(cmd, addr, blk_count, zero_page);
+	lodata.blk_count = blk_count;
+	lodata.blk_size = device.blk_size;
+	blk_end = blk + blk_count - 1;
+
+	/* Compute start track and end block on track */
+	trk = blk / device.bpt;
+	bot = (blk % device.bpt) + 1;
+	/* Compute start cylinder and head */
+	cyl = trk / device.num_heads;
+	hd = trk % device.num_heads;
+
+	lodata.bot = (uint8_t) bot;
+
+	/* Upper 12 bits of cylinder are coded into heads: c0c1c2h0 (2 byte) */
+	c0c1c2h0 = cyl >> 16;
+	c0c1c2h0 <<= 4;
+
+	/* Combine to CCHH */
+	down = cyl << 16;
+
+	dedata.cchh1 = down | hd | c0c1c2h0;
+	lodata.cchh1 = down | hd | c0c1c2h0;
+	lodata.cchh2 = down | hd | c0c1c2h0;
+
+	/* Compute end track and end block on track */
+	trk_end = blk_end / device.bpt;
+	/* Compute end cylinder and head */
+	cyl_end = trk_end / device.num_heads;
+	hd_end = trk_end % device.num_heads;
+
+	/* Upper 12 bits of cylinder are coded into heads: c0c1c2h0 (2 byte) */
+	c0c1c2h0 = cyl_end >> 16;
+	c0c1c2h0 <<= 4;
+
+	/* Combine to CCHH */
+	down = cyl_end << 16;
+
+	dedata.cchh2 = down | hd_end | c0c1c2h0;
+	start_io(device.ssid, &irb, &orb);
+}
+
+/*
+ * Write data to given block address
+ */
+void writeblock(unsigned long blk, unsigned long addr, unsigned long blk_count,
+		unsigned long zero_page)
+{
+	lodata.op = 0x01; /* Indicate WRITE DATA operation */
+	dedata.op = 0x80; /* Permit update write operations */
+	io_block(CMD_WRITE, blk, addr, blk_count, zero_page);
+}
+
+/*
+ * Read data from given block address
+ */
+void readblock(unsigned long blk, unsigned long addr, unsigned long blk_count)
+{
+	lodata.op = 0x06; /* Indicate READ DATA operation */
+	dedata.op = 0x40; /* Inhibit all write operations */
+	io_block(CMD_READ, blk, addr, blk_count, 0);
+}
+
+/*
+ * Init ECKD common
+ */
+void stage2dump_eckd_init(void)
+{
+	ccw_program.deccw.cmd_code = CMD_DEFINE_EXTEND;
+	ccw_program.deccw.flags = CCW_FLAG_CC;
+	ccw_program.deccw.count = 0x0010;
+	ccw_program.deccw.cda = __pa32(&dedata);
+
+	ccw_program.loccw.cmd_code = CMD_LOCATE_RECORD;
+	ccw_program.loccw.flags = CCW_FLAG_CC;
+	ccw_program.loccw.count = 0x0010;
+	ccw_program.loccw.cda = __pa32(&lodata);
+
+	orb.cpa = __pa32(&ccw_program);
+}
--- /dev/null
+++ b/zipl/boot/eckd2dump.h
@@ -0,0 +1,49 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common ECKD dump I/O functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+#ifndef ECKD2DUMP_H
+#define ECKD2DUMP_H
+
+#include "cio.h"
+
+#define ECKD_BPWRT_MAX 64
+
+struct eckd_device {
+	uint32_t blk_start;
+	uint32_t blk_end;
+	uint16_t blk_size;
+	uint8_t num_heads;
+	uint8_t bpt;
+	struct subchannel_id ssid;
+	uint16_t devno;
+};
+
+extern struct eckd_device device;
+
+/*
+ * Convert memory size to number of blocks
+ */
+static inline unsigned long m2b(unsigned long mem)
+{
+	return mem / device.blk_size;
+}
+
+/*
+ * Convert number of blocks to memory size
+ */
+static inline unsigned long b2m(unsigned long blk)
+{
+	return blk * device.blk_size;
+}
+
+void stage2dump_eckd_init();
+void writeblock(unsigned long blk, unsigned long addr, unsigned long blk_count,
+		unsigned long zero_page);
+void readblock(unsigned long blk, unsigned long addr, unsigned long blk_count);
+
+#endif /* ECKD2DUMP_H */
